//---------------------------------------------------------------------------
#include <windows.h>
#include "tp_stub.h"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// BMP ł̉摜ۑ
//---------------------------------------------------------------------------
void SaveAsBMP(const ttstr & name, tjs_int width, tjs_int height,
	const tjs_uint8 * bufferptr, tjs_int bufferpitch)
{
	// BMP ŉ摜ۑ

	// Xg[J
	IStream * out = TVPCreateIStream(name, TJS_BS_WRITE);
	if(!out)
		TVPThrowExceptionMessage((ttstr(TJS_W("cannot open : ")) +
			ttstr(name)).c_str());
	tjs_uint8 * buf = NULL;

	try
	{
		// gg̉摜LbVNA
		// sȂƁA摜t@Cɏł
		// gg̃LbVQƂĂ܂
		TVPClearGraphicCache();


		// wb_
		tjs_uint pitch = width*4;
		tjs_uint srcpitch = bufferpitch < 0 ? -bufferpitch : bufferpitch;

		BITMAPFILEHEADER bfh;
		bfh.bfType = 'B' + ('M' << 8);
		bfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) +
			pitch * height;
		bfh.bfReserved1 = 0;
		bfh.bfReserved2 = 0;
		bfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

		unsigned long written;
		out->Write(&bfh, sizeof(bfh), &written);
		if(written != sizeof(bfh))
			TVPThrowExceptionMessage((ttstr(TJS_W("write failed : ")) +
				ttstr(name)).c_str());

		BITMAPINFOHEADER bih;
		bih.biSize = sizeof(bih);
		bih.biWidth = width;
		bih.biHeight = height;
		bih.biPlanes = 1;
		bih.biBitCount = 32;
		bih.biCompression = BI_RGB;
		bih.biSizeImage = 0;
		bih.biXPelsPerMeter = 0;
		bih.biYPelsPerMeter = 0;
		bih.biClrUsed = 0;
		bih.biClrImportant = 0;

		out->Write(&bih, sizeof(bih), &written);
		if(written != sizeof(bih))
			TVPThrowExceptionMessage((ttstr(TJS_W("write failed : ")) +
				ttstr(name)).c_str());


		// rbg}bvo
		buf = new tjs_uint8 [pitch];
		bufferptr += bufferpitch * (height-1);

		for(tjs_int y = 0; y < height; y++)
		{
			memcpy(buf, bufferptr, srcpitch);
			out->Write(buf, pitch, &written);
			if(written != pitch)
				TVPThrowExceptionMessage((ttstr(TJS_W("write failed : ")) +
					ttstr(name)).c_str());
			bufferptr -= bufferpitch; // ㉺tɕۑ̂
		}

	}
	catch(...)
	{
		out->Release();
		if(buf) delete [] buf;
		throw;
	}

	out->Release();
	if(buf) delete [] buf;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C̉摜ۑ邽߂̊֐ ( TJS ֐ )
//---------------------------------------------------------------------------
class tSaveLayerImageFunction : public tTJSDispatch
{
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis)
	{
		if(membername) return TJS_E_MEMBERNOTFOUND;

		//  : C, t@C, 摜` [, 摜ŗLIvV ...]
		if(numparams < 3) return TJS_E_BADPARAMCOUNT;

		const tjs_uint8 * bufferptr;
		tjs_int bufferpitch;
		tjs_int width;
		tjs_int height;

		// 摜̃TCYAsNZobt@ւ̃|C^Asb`𓾂
		iTJSDispatch2 * layerobj = param[0]->AsObjectNoAddRef();

		tTJSVariant val;
		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("imageWidth"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.imageWidth failed."));
		width = val;

		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("imageHeight"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.imageHeight failed."));
		height = val;

		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("mainImageBuffer"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.mainImageBuffer failed."));
		bufferptr = (const tjs_uint8 *)(tjs_int)val;

		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("mainImageBufferPitch"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.mainImageBufferPitch failed."));
		bufferpitch = val;

		// 摜``FbN
		ttstr format = *param[2];
		if(format == TJS_W("bmp"))
		{
			// BMP ŕۑ
			SaveAsBMP(*param[1], width, height, bufferptr, bufferpitch);
		}
		else
		{
			TVPThrowExceptionMessage(TJS_W("Not supported format."));
		}

		// ߂l void
		if(result) result->Clear();

		// ߂
		return TJS_S_OK;
	}
} * SaveLayerImageFunction;
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;
extern "C" HRESULT _stdcall _export V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	// SaveLayerImageFunction ̍쐬Ɠo^
	tTJSVariant val;

	// TJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// 1 ܂IuWFNg쐬
	SaveLayerImageFunction = new tSaveLayerImageFunction();

	// 2 SaveLayerImageFunction  tTJSVariant ^ɕϊ
	val = tTJSVariant(SaveLayerImageFunction);

	// 3 ł val  SaveLayerImageFunction ێĂ̂ŁA
	// SaveLayerImageFunction  Release 
	SaveLayerImageFunction->Release();


	// 4 global  PropSet \bhpAIuWFNgo^
	global->PropSet(
		TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
		TJS_W("saveLayerImage"), // o ( Ȃ炸 TJS_W( ) ň͂ )
		NULL, // qg ( {̓õnbVlANULL ł悢 )
		&val, // o^l
		global // ReLXg ( global ł悢 )
		);


	// - global  Release 
	global->Release();

	// val NAB
	// ͕KsBȂ val ێĂIuWFNg
	//  Release ꂸAɎg TVPPluginGlobalRefCount mɂȂȂB
	val.Clear();


	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	TVPAddLog(TVPPluginGlobalRefCount);
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall _export V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐B

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	TVPAddLog(TVPPluginGlobalRefCount);
	if(TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;
		// E_FAIL AƁAPlugins.unlink \bh͋UԂ

	// TJS ̃O[oIuWFNgɓo^ saveLayerImage ֐폜

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// - global  DeleteMember \bhpAIuWFNg폜
	if(global)
	{
		// TJS ̂ɉĂƂȂǂ
		// global  NULL ɂȂ蓾̂ global  NULL łȂ
		// Ƃ`FbN

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("saveLayerImage"), // o
			NULL, // qg
			global // ReLXg
			);
			// o^֐ꍇ JԂ
	}

	// - global  Release 
	if(global) global->Release();

	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	return S_OK;
}
//---------------------------------------------------------------------------



